/*
 * include/asm-ppc/mv_pmc8245_serial.h
 * 
 * Definitions for Marvell MV_PMC8245 Test Platform
 *
 * Author: Aharon Gadot aharong@radlan.com
 *
 * Copyright 2004 Radlan a Marvell Company Ltd.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

#ifndef __ASMPPC_MV_PMC8245_SERIAL_H
#define __ASMPPC_MV_PMC8245_SERIAL_H

#include <linux/config.h>

#define MV_PMC8245_SERIAL_0		0xff000000
#define MV_PMC8245_SERIAL_0_IRQ	2


#ifdef CONFIG_SERIAL_MANY_PORTS
#define RS_TABLE_SIZE  64
#else
#define RS_TABLE_SIZE  1
#endif

/* Rate for the 1.8432 Mhz clock for the onboard serial chip */
#define BASE_BAUD ( 1843200 / 16 )


#ifdef CONFIG_SERIAL_DETECT_IRQ
#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST|ASYNC_AUTO_IRQ)
#else
#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST)
#endif

#define STD_SERIAL_PORT_DFNS                                            \
	    /* ttyS0 */			                            				\
        { 0, BASE_BAUD, MV_PMC8245_SERIAL_0, MV_PMC8245_SERIAL_0_IRQ,   \
        STD_COM_FLAGS, iomem_base: (u8 *)MV_PMC8245_SERIAL_0,	        \
		io_type: SERIAL_IO_MEM }

#define SERIAL_PORT_DFNS \
        STD_SERIAL_PORT_DFNS

#endif /* __ASMPPC_MV_PMC8245_SERIAL_H */
