/*
 * A collection of structures, addresses, and values associated with
 * all mpc8xx-based boards from SwitchCore.
 *
 * Copyright (c) 2004 SwitchCore AB
 *
 * Based on header file for Motorola 860T FADS board,
 * Copyright (c) 1998 Dan Malek (dmalek@jlc.net)
 */
#ifdef __KERNEL__
#ifndef __ASM_SWITCHCORE_MPC8XX_H__
#define __ASM_SWITCHCORE_MPC8XX_H__

#include <linux/config.h>

#include <asm/ppcboot.h>

#define IMAP_ADDR		((uint)0xff000000)
#define IMAP_SIZE		((uint)(64 * 1024))

#if defined(CONFIG_IDE) /* Compact Flash support, use CONFIG_IDE_8xx_PCCARD */
#define MAX_HWIFS 1

/*
 * Definitions for IDE0 Interface
 */

/* We assume that pcmcia memory windows are initialized by u-boot.
 * The constant PCMCIA_MEM_SIZE below should match the value of
 * CFG_PCMCIA_MEM_SIZE in u-boot... 
 */

#define PCMCIA_MEM_SIZE	               ((uint)(64 << 20))

#define IDE0_BASE_OFFSET               0
#define IDE0_DATA_REG_OFFSET           (PCMCIA_MEM_SIZE + 0x320)
#define IDE0_ERROR_REG_OFFSET          (2 * PCMCIA_MEM_SIZE + 0x320 + 1)
#define IDE0_NSECTOR_REG_OFFSET        (2 * PCMCIA_MEM_SIZE + 0x320 + 2)
#define IDE0_SECTOR_REG_OFFSET         (2 * PCMCIA_MEM_SIZE + 0x320 + 3)
#define IDE0_LCYL_REG_OFFSET           (2 * PCMCIA_MEM_SIZE + 0x320 + 4)
#define IDE0_HCYL_REG_OFFSET           (2 * PCMCIA_MEM_SIZE + 0x320 + 5)
#define IDE0_SELECT_REG_OFFSET         (2 * PCMCIA_MEM_SIZE + 0x320 + 6)
#define IDE0_STATUS_REG_OFFSET         (2 * PCMCIA_MEM_SIZE + 0x320 + 7)
#define IDE0_CONTROL_REG_OFFSET        0x0106
#define IDE0_IRQ_REG_OFFSET            0x000A  /* not used */

#define	IDE0_INTERRUPT		       SIU_LEVEL6

#endif /* CONFIG_IDE */

/* Interrupt level assignments.
 */
#define FEC_INTERRUPT	SIU_LEVEL1	/* FEC interrupt */
#define PHY_INTERRUPT	SIU_IRQ2	/* PHY link change interrupt */

/* We don't use the 8259.
 */
#define NR_8259_INTS	0

#endif /* __ASM_SWITCHCORE_MPC8XX_H__ */
#endif /* __KERNEL__ */
