/*
 * Memory sub-system initialization code for BCM94702CPCI.
 *
 * Copyright (c) 2003	LVL7 Systems, Inc.
 * John W. Linville <linville@lvl7.com>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <version.h>
#include <asm/regdef.h>

#define	SDRAM_INIT	0x419
#define	SDRAM_CONFIG	0x0000
#define	SDRAM_REFRESH	0x8040

	.globl	memsetup
memsetup:

	/* Did not find an NVRAM block, use defaults for SDRAM */
	li	t0, SDRAM_INIT
	li	t1, SDRAM_CONFIG
	li	t2, SDRAM_REFRESH

	/* SDRAM init */
	li	a0, 0xB8000f98
	li	a1, 0x00030001
	sw	a1, 0(a0)
	lw	a1, 0(a0)	/* use multiple loads to insert a delay */
	lw	a1, 0(a0)
	lw	a1, 0(a0)
	li	a1, 0x00030000
	sw	a1, 0(a0)
	lw	a1, 0(a0)	/* use multiple loads to insert a delay */
	lw	a1, 0(a0)
	lw	a1, 0(a0)
	li	a1, 0x00010000
	sw	a1, 0(a0)
	lw	a1, 0(a0)	/* use multiple loads to insert a delay */
	lw	a1, 0(a0)
	lw	a1, 0(a0)
	li	a0, 0xB8000000	# SDRAM registers

	sw	t1, 4(a0)	# SDRAM config
	li	a1, 0x000a
	sw	a1, 0(a0)
	li	a1, 0x000c
	sw	a1, 0(a0)
	li	a1, 0x0009
	sw	a1, 0(a0)	# 1st refresh of power up sequence
	sw	a1, 0(a0)	# 2nd refresh of power up sequence
	sw	a1, 0(a0)	# 3rd refresh of power up sequence
	sw	a1, 0(a0)	# 4th refresh of power up sequence
	sw	a1, 0(a0)	# 5th refresh of power up sequence
	sw	a1, 0(a0)	# 6th refresh of power up sequence
	sw	a1, 0(a0)	# 7th refresh of power up sequence
	sw	a1, 0(a0)	# 8th refresh of power up sequence
	sw	t0, 0(a0)	# SDRAM init
	sw	t2, 8(a0)	# SDRAM refresh

	j	ra
	nop
