/*
 * (C) Copyright 2003
 * John W. Linville, LVL7 Systems, Inc., linville@lvl7.com.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>

int checkboard (void)
{

	printf("Board: Broadcom BCM95836CPCI\n");

	return 0;
}

long int initdram (int board_type)
{
	int		 i, cnt;
	volatile uchar * base = (volatile uchar *)CFG_SDRAM_BASE;
	volatile ulong * addr;
	ulong		 save[32];
	ulong		 val, ret  = 0;

	for (i=0, cnt=(CFG_MAX_RAM_SIZE / sizeof(long)) >> 1;
	     cnt > 0; cnt >>= 1) {
		addr = (volatile ulong *)base + cnt;
		save[i++] = *addr;
		*addr = ~cnt;
	}

	addr = (volatile ulong *)base;
	save[i] = *addr;
	*addr = 0;

	if (*addr != 0) {
		*addr = save[i];
		goto Done;
	}

	for (cnt = 1; cnt <= CFG_MAX_RAM_SIZE / sizeof(long); cnt <<= 1) {
		addr = (volatile ulong *)base + cnt;
		val = *addr;
		*addr = save[--i];
		if (val != ~cnt) {
			ret = cnt * sizeof(long);
			goto Done;
		}
	}

	ret = CFG_MAX_RAM_SIZE;
Done:
	return ret;
}

int board_pre_init(void)
{
	/* Enable CS01 (aka M_CS1) */
	*((volatile ulong *)0xb8000100) = 0x00000001;

	/* Set timings for CS01 */
	*((volatile ulong *)0xb8000104) = 0x0100010a;

	/* Enable CS23 (aka M_CS2) */
	*((volatile ulong *)0xb8000110) = 0x00000001;

	/* Set timings for CS23 */
	*((volatile ulong *)0xb8000114) = 0x0100010a;

	/* Enable CS4  (aka M_CS3) */
	*((volatile ulong *)0xb8000120) = 0x00000001;

	/* Set timings for CS4 */
	*((volatile ulong *)0xb8000124) = 0x0100010a;

	/* Set timings for FLASH_CS */
	*((volatile ulong *)0xb800012c) = 0x0100010a;

	/* Set divider for UART clock */
	*((volatile ulong *)0xb80000a4) = 0x00000036;

	/* Set SBIPSFlag for MIPS core */
	*((volatile ulong *)0xb8005f08) = 0x043f0201;

	/* Set SBIntVec for MIPS core */
	*((volatile ulong *)0xb8005f94) = 0x00000001;

	/* Enable write of NVRAM */
	*((volatile ulong *)0xba008000) = 0x00000000;
	
	/* Reset ENET 0 */
	*((volatile ulong *)0xb8001f98) = 0x00030001;

	udelay(1000);

	*((volatile ulong *)0xb8001f98) = 0x00030000;

	udelay(1000);

	*((volatile ulong *)0xb8001f98) = 0x00010000;

	udelay(100);

	return (0);
}
